<template>
  <ModalsBase
    :id="id"
    :title="`Import into a project`"
    :footer="true"
    :header="true"
    ok-title="Import"
    bodyclass="p-0"
    :close-backdrop="!selectOpen"
    :ok-disabled="!selectedProject"
    @ok="importIntoProject()"
    @shown="clearSelect()"
  >
    <template #body>
      <div class="p-3">
        <div class="mb-3">
          <div class="subheader mb-2">
            {{ objectType | capitalize }} to import
          </div>
          <div class="mb-3">
            {{ object.title || object.name }}
          </div>
          <div class="subheader mb-2">Project</div>
          <RimowSelectize
            placeholder="Select a project..."
            item-icon="package"
            :max-chars="30"
            :options="projects"
            :selected="selectedProject"
            :clearable="false"
            data-cy="import-into-project-selectize"
            @change="changeProject"
            @focus="selectFocus"
            @blur="selectBlur"
          >
            <template #button-append></template>
          </RimowSelectize>
        </div>
      </div>
    </template>
  </ModalsBase>
</template>
<script>
import { mapGetters } from 'vuex';
import notificationsMixin from '~/mixins/notifications.js';
import helpersMixin from '~/mixins/helpers.js';
export default {
  mixins: [notificationsMixin, helpersMixin],
  props: {
    id: {
      type: String,
      default: '',
    },
  },
  data() {
    return {
      selectedProject: undefined,
      selectOpen: false,
    };
  },
  async fetch() {
    await this.$nuxt.context.store.dispatch('projects/fetchProjects');
  },
  computed: {
    ...mapGetters({
      projects: 'projects/allProjects',
    }),
    projects() {
      let projectProperty;
      if (this.objectType === 'scenario') {
        projectProperty = 'scenarios';
      } else if (this.objectType === 'dataset') {
        projectProperty = 'datasets';
      } else {
        return [];
      }
      const allProjects =
        this.$nuxt.context.store.getters['projects/allProjects'];
      return allProjects
        .filter((project) => {
          const propertyIds = project[projectProperty].map((el) => el.id);
          return !propertyIds.includes(this.object.id);
        })
        .map((project) => {
          return {
            id: project.id,
            title: project.title,
            description: project.short_description,
          };
        });
    },
    modalData() {
      return this.$nuxt.context.store.getters['ui/projectImportModal'];
    },
    objectType() {
      return this.modalData.type;
    },
    object() {
      return this.modalData.object;
    },
  },
  methods: {
    async importIntoProject() {
      let response;
      if (this.objectType === 'scenario') {
        response = await this.$nuxt.context.store
          .dispatch('projects/linkScenario', {
            projectId: this.selectedProject.id,
            scenarioId: this.object.id,
          })
          .catch(() => {
            this.showErrorNotification('Error linking scenario');
            return null;
          });
      } else if (this.objectType === 'dataset') {
        response = await this.$nuxt.context.store
          .dispatch('projects/linkDataset', {
            projectId: this.selectedProject.id,
            datasetId: this.object.id,
          })
          .catch(() => {
            this.showErrorNotification('Error linking dataset');
            return null;
          });
      }
      if (response) {
        this.$store.commit('ui/setSearchWorkspaceVisible', false);
        this.$router.push({
          path: `/projects/${this.selectedProject.id}/view`,
        });
      }
    },
    selectFocus() {
      this.selectOpen = true;
    },
    async selectBlur() {
      await this.wait(100);
      this.selectOpen = false;
    },
    changeProject(project) {
      this.selectedProject = project;
    },
    clearSelect() {
      this.selectedProject = undefined;
    },
  },
};
</script>
